/*******************************************************************************
 * FoxCamera generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCamera extends GamePlayerCamera
    transient
    native(Camera)
    hidecategories(Navigation);

var FoxCamMod_Zoom FoxCamMod_Zoom;
var transient FoxPC FoxPCOwner;
var transient float NarcissistTimer;
var transient float MaxNarcissistTimer;
var(Camera) editinline transient GameCameraBase CorpseCam;
var(Camera) protected const class<GameCameraBase> CorpseCamClass;
var(Camera) editinline transient GameCameraBase FirstPersonCam;
var(Camera) protected const class<GameCameraBase> FirstPersonCamClass;
var(Camera) editinline transient GameCameraBase SpectatePlayerCam;
var(Camera) protected const class<GameCameraBase> SpectatePlayerCamClass;
var(Camera) editinline transient GameCameraBase PreviewCam;
var(Camera) protected const class<GameCameraBase> PreviewCamClass;
var(Camera) editinline transient GameCameraBase HeroCam;
var(Camera) protected const class<GameCameraBase> HeroCamClass;
var(Camera) editinline transient GameCameraBase BeaconCam;
var(Camera) protected const class<GameCameraBase> BeaconCamClass;

simulated function PostBeginPlay()
{
    super.PostBeginPlay();
    // End:0x3F
    if(FoxCamMod_Zoom == none)
    {
        FoxCamMod_Zoom = FoxCamMod_Zoom(CreateCameraModifier(class'FoxCamMod_Zoom'));
    }
    // End:0x7C
    if((CorpseCam == none) && CorpseCamClass != none)
    {
        CorpseCam = CreateCamera(CorpseCamClass);
    }
    // End:0xB9
    if((FirstPersonCam == none) && FirstPersonCamClass != none)
    {
        FirstPersonCam = CreateCamera(FirstPersonCamClass);
    }
    // End:0xF6
    if((SpectatePlayerCam == none) && SpectatePlayerCamClass != none)
    {
        SpectatePlayerCam = CreateCamera(SpectatePlayerCamClass);
    }
    // End:0x133
    if((PreviewCam == none) && PreviewCamClass != none)
    {
        PreviewCam = CreateCamera(PreviewCamClass);
    }
    // End:0x170
    if((HeroCam == none) && HeroCamClass != none)
    {
        HeroCam = CreateCamera(HeroCamClass);
    }
    // End:0x1AD
    if((BeaconCam == none) && BeaconCamClass != none)
    {
        BeaconCam = CreateCamera(BeaconCamClass);
    }
    //return;    
}

// Export UFoxCamera::execIsFirstPerson(FFrame&, void* const)
native function bool IsFirstPerson();

protected simulated function GameCameraBase FindBestCameraType(Actor CameraTarget)
{
    local FoxPawn PawnTarget;

    // End:0x1DD
    if(FoxPawn(CameraTarget) != none)
    {
        PawnTarget = FoxPawn(CameraTarget);
        // End:0x1D0
        if(PawnTarget.IsAliveAndWell())
        {
            // End:0xBE
            if(PawnTarget.Controller == FoxPCOwner)
            {
                // End:0xB1
                if(PawnTarget.bWantsThirdPersonCamera)
                {
                    return ThirdPersonCam;
                }
                // End:0xBB
                else
                {
                    return FirstPersonCam;
                }
            }
            // End:0x1CD
            else
            {
                // End:0x194
                if((((FoxPCOwner.PawnSpectateView == 1) && !PawnTarget.IsInjured()) && PawnTarget.IsAliveAndWell()) && (FoxPCOwner.CurrentSpectateMode == 3) || FoxPCOwner.CurrentSpectateMode == 1)
                {
                    return FirstPersonCam;
                }
                // End:0x1CD
                else
                {
                    // End:0x1C3
                    if(PawnTarget.IsInjured())
                    {
                        return CorpseCam;
                    }
                    // End:0x1CD
                    else
                    {
                        return SpectatePlayerCam;
                    }
                }
            }
        }
        // End:0x1DA
        else
        {
            return CorpseCam;
        }
    }
    // End:0x256
    else
    {
        // End:0x202
        if(FoxCustomActor(CameraTarget) != none)
        {
            return PreviewCam;
        }
        // End:0x256
        else
        {
            // End:0x227
            if(FoxCameraActor_HeroPose(CameraTarget) != none)
            {
                return HeroCam;
            }
            // End:0x256
            else
            {
                // End:0x24C
                if(FoxProjectile_BeaconBase(CameraTarget) != none)
                {
                    return BeaconCam;
                }
                // End:0x256
                else
                {
                    return FixedCam;
                }
            }
        }
    }
    //return ReturnValue;    
}

function InitializeFor(PlayerController PC)
{
    super(Camera).InitializeFor(PC);
    FoxPCOwner = FoxPC(PC);
    //return;    
}

simulated event UpdateCamera(float DeltaTime)
{
    local GameCameraBase SavedCam;

    SavedCam = CurrentCamera;
    // End:0x81
    if((FoxPCOwner != none) && FoxPCOwner.MyFoxPawn != none)
    {
        FoxPCOwner.MyFoxPawn.bClearCachedViewLocation = true;
    }
    // End:0x132
    else
    {
        // End:0x132
        if((FoxPawn(ViewTarget.Target) != none) && FoxPawn(ViewTarget.Target).IsBeingFPSpectatedBy(FoxPCOwner))
        {
            FoxPawn(ViewTarget.Target).bClearCachedViewLocation = true;
        }
    }
    super(Camera).UpdateCamera(DeltaTime);
    // End:0x166
    if(SavedCam != CurrentCamera)
    {
        OnCameraModeChanged();
    }
    // End:0x1D8
    if((FoxPCOwner != none) && FoxPCOwner.MenuMesh != none)
    {
        FoxPCOwner.MenuMesh.Update(DeltaTime);
    }
    //return;    
}

function OnCameraModeChanged()
{
    // End:0x8D
    if(((FoxPCOwner != none) && FoxPCOwner.MyFoxPawn != none) && FoxPCOwner.IsLocalPlayerController())
    {
        FoxPCOwner.MyFoxPawn.RestoreMeshVisibility();
    }
    //return;    
}

function RemoveCameraLensEffect(EmitterCameraLensEffectBase Emitter)
{
    super(Camera).RemoveCameraLensEffect(Emitter);
    // End:0xBF
    if(((FoxPCOwner != none) && FoxPCOwner.MyFoxPawn != none) && Emitter == FoxPCOwner.MyFoxPawn.HRVJammerLensEffect)
    {
        FoxPCOwner.MyFoxPawn.ResetHRVJammerLensEffect();
    }
    //return;    
}

simulated function DoUpdateCamera(float DeltaTime)
{
    // End:0x13F
    if(((((FoxCustomActor(ViewTarget.Target) == none) && FoxPCOwner != none) && FoxPCOwner.DynamicUI != none) && FoxPCOwner.DynamicUI.Menu != none) && (FoxPCOwner.DynamicUI.Menu.ArmoryInfo != none) || FoxPCOwner.DynamicUI.Menu.StoreExtended != none)
    {
        return;
    }
    super(Camera).DoUpdateCamera(DeltaTime);
    //return;    
}

function SetViewTarget(Actor NewViewTarget, optional ViewTargetTransitionParams TransitionParams)
{
    super(Camera).SetViewTarget(NewViewTarget, TransitionParams);
    // End:0x114
    if(((((FoxPCOwner != none) && FoxPCOwner.Role == ROLE_Authority) && FoxPawn(NewViewTarget) != none) && FoxPCOwner.bWantsSpectateThroughDeath) && FoxPCOwner.PlayerReplicationInfo.bOnlySpectator)
    {
        FoxPCOwner.ControllerToFollow = FoxPawn(NewViewTarget).Controller;
    }
    //return;    
}

defaultproperties
{
    MaxNarcissistTimer=1.0
    CorpseCamClass=class'FoxCorpseCamera'
    FirstPersonCamClass=class'FoxFirstPersonCamera'
    SpectatePlayerCamClass=class'FoxFollowCamera'
    PreviewCamClass=class'FoxPreviewCamera'
    HeroCamClass=class'FoxHeroCamera'
    BeaconCamClass=class'FoxBeaconCamera'
    ThirdPersonCameraClass=class'FoxThirdPersonCamera'
    FixedCameraClass=class'FoxFirstPersonCamera'
    DefaultFOV=65.0
    bEnableFading=true
    bHidden=false
}